//	Distributed under the Boost Software License Version 1.0 https://www.boost.org/LICENSE_1_0.txt
//	Copyright Gero Peterhoff

#ifndef BOOST_QUADMATH_INTEL_IO_HPP
#define BOOST_QUADMATH_INTEL_IO_HPP

#include <cstdint>
#include <iostream>
#include <boost/config.hpp>
#include <boost/quadmath/quadmath_intel.hpp>

#if !defined(BOOST_NO_CXX17_HDR_CHARCONV)
#include <charconv>
#endif



#if BOOST_INTEL
namespace std
{
#if !defined(BOOST_NO_CXX17_HDR_CHARCONV)
inline from_chars_result	from_chars(const char*const first, const char*const last, __float128& value, chars_format fmt = chars_format::general)	noexcept
{
	//	todo
	return from_chars_result{};
}

inline to_chars_result		to_chars(char* first, char* last, const __float128 value, const chars_format fmt, const int precision)	noexcept
{
	//	todo
	return to_chars_result{};
}

inline to_chars_result		to_chars(char* first, char* last, const __float128 value, const chars_format fmt)	noexcept
{
	//	todo
	return to_chars_result{};
}

inline to_chars_result		to_chars(char* first, char* last, const __float128 value)	noexcept
{
	//	todo
	return to_chars_result{};
}
#endif	//	BOOST_NO_CXX17_HDR_CHARCONV

inline wstring	to_wstring(const __float128 val)	noexcept
{
	//	todo
	return wstring{};
}

inline string	to_string(const __float128 val)		noexcept
{
	//	todo
	return string{};
}

template <typename Char, typename Traits>
BOOST_NOINLINE basic_ostream<Char, Traits>&  operator<<(basic_ostream<Char, Traits>& stream, const __float128 val)	noexcept
{
	//	todo
	return stream;
}

template <typename Char, typename Traits>
BOOST_NOINLINE basic_istream<Char, Traits>&  operator>>(basic_istream<Char, Traits>& stream, __float128& val)	noexcept
{
	//	todo
	return stream;
}
}	//	std
#endif	//	BOOST_INTEL
#endif	//	BOOST_QUADMATH_INTEL_IO_HPP
